---
title: Response.useFinalURL
slug: Web/API/Response/useFinalURL
tags:
  - API
  - Experimental
  - Fetch
  - Obsolete
  - Property
  - Reference
  - Response
  - useFinalURL
---
<div>{{APIRef("Fetch")}}{{obsolete_header}}</div>

<p>The <strong><code>useFinalURL</code></strong> property of the {{domxref("Response")}} interface contains a boolean stating whether this is the final URL of the response.</p>

<div class="note">
<p>This property applies only to <a href="/en-US/docs/Web/API/ServiceWorker_API">ServiceWorkers</a>. In other contexts it will return <code>undefined</code>.</p>
</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">var <var>isfinalURL</var> = <var>Response</var>.useFinalURL;</pre>

<h3 id="Value">Value</h3>

<p>A {{domxref("Boolean")}} indicating whether or not the URL is final rather than a redirect.</p>

<h2 id="Example">Example</h2>

<p>Consider a script residing in page <code>index.html</code>:</p>

<pre class="brush: js">fetch('/test').then((r) =&gt; console.log(r.url))</pre>

<p><code>test.html</code> is being controlled by the service worker <code>sw.js</code>:</p>

<pre class="brush: js">onfetch = (e) =&gt; {
  e.respondWith(fetch('/page2').then((r) =&gt; {
    r.usefinalURL = true;
    return r;
  })
}</pre>

<p>The output will be <code>/page2</code> and not <code>/test</code> in <code>index.html</code>, since setting the <code>usefinalURL</code> means that the response's URL is not set to request's URL.</p>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.Response.useFinalURL")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/ServiceWorker_API">ServiceWorker API</a></li>
 <li><a href="/en-US/docs/Web/HTTP/Access_control_CORS">HTTP access control (CORS)</a></li>
 <li><a href="/en-US/docs/Web/HTTP">HTTP</a></li>
</ul>
